package main

import (
	"flag"

	"github.com/zeromicro/go-zero/core/logx"

	"code.30cm.net/digimon/app-cloudep-order-service/gen_result/pb/order"
	"code.30cm.net/digimon/app-cloudep-order-service/internal/config"
	orderserviceServer "code.30cm.net/digimon/app-cloudep-order-service/internal/server/orderservice"
	"code.30cm.net/digimon/app-cloudep-order-service/internal/svc"

	"github.com/zeromicro/go-zero/core/conf"
	"github.com/zeromicro/go-zero/core/service"
	"github.com/zeromicro/go-zero/zrpc"
	"google.golang.org/grpc"
	"google.golang.org/grpc/reflection"
)

var configFile = flag.String("f", "etc/order.yaml", "the config file")

func main() {
	flag.Parse()

	var c config.Config
	conf.MustLoad(*configFile, &c)
	ctx := svc.NewServiceContext(c)

	s := zrpc.MustNewServer(c.RpcServerConf, func(grpcServer *grpc.Server) {
		order.RegisterOrderServiceServer(grpcServer, orderserviceServer.NewOrderServiceServer(ctx))

		if c.Mode == service.DevMode || c.Mode == service.TestMode {
			reflection.Register(grpcServer)
		}
	})
	defer s.Stop()

	logx.Infof("Starting rpc server at %s...\n", c.ListenOn)
	s.Start()
}
